#!/bin/bash

# Zenwalk Gnu/Linux build script written for "wm-applets"
# Soft Home Page;	libdockapp:	http://freshmeat.net/redir/libdockapp/64308/url_homepage/libdockapp
# Soft Home Page;	wmvolman:	http://people.altlinux.ru/~raorn/wmvolman.html
# Source URL;		wmvolman:	http://people.altlinux.ru/~raorn/wmvolman-0.9.tar.bz2
# Software's Dependencies: 
# Package Maintainer: Michael Verret (axxium) axxium.zenlnx@gmail.com


#------------------( Unique Package Variables )


SOFT='wm-applets'
SOFTVERSION='0.92.0'
BUILDVERSION='50.1'
ARCH='i486'
CPU='i686'
PACKAGE="$SOFT-$SOFTVERSION-$ARCH-$BUILDVERSION"
BUILDIR=$(pwd)
DEST="$BUILDIR/$PACKAGE"


#------------------( wm-applets Source )


SOURCES=" \
		asmon-0.7.tar.bz2 \
		libdockapp-0.6.1.tar.bz2 \
		Mixer.app-1.8.0.tar.gz \
		wmCalClock-1.25.tar.bz2 \
		wmMatrix-0.2.tar.bz2 \
		wmeyes.tar.bz2 \
		wmfsm-0.34.linux-fs.patch \
		wmfsm-0.34.tar.bz2 \
		wmifs.app.tar.bz2 \
		wmtetris-0.1.tar.bz2 \
		wmtictactoe-1.1-1.tar.bz2 \
		wmvolman-0.9.tar.bz2"


for file in $SOURCES ; do
	echo -n "$file :"
		if [ -e $file ]; then
        		echo " OK"
		else
			echo " MISSING !"
			exit 1
		fi
done


#------------------( Clean Work Directory )


cd $BUILDIR

rm -rf \
	$DEST $DEST.dep $DEST.md5 $DEST.tgz \
	asmon-0.7 \
	dockapp-0.6.1 \
	Mixer.app-1.8.0 \
	wmCalClock-1.25 \
	wmMatrix-0.2 \
	wmeyes-0.1 \
	wmfsm-0.34 \
	wmifs.app \
	wmtetris-0.1 \
	wmtictactoe-1.1-1 1>/dev/null 2>&1


#------------------( Create The Necessary Package Directories )


mkdir -p $DEST/etc/WindowMaker/Zenwalk-Defaults/Menus
mkdir -p $DEST/install
mkdir -p $DEST/usr/bin
mkdir -p $DEST/usr/doc/asmon-0.7
mkdir -p $DEST/usr/doc/libdockapp-0.6.1
mkdir -p $DEST/usr/doc/mixer.app-1.8.0
mkdir -p $DEST/usr/doc/wmvolman-0.9
mkdir -p $DEST/usr/doc/wmCalClock-1.25
mkdir -p $DEST/usr/doc/wmMatrix-0.2
mkdir -p $DEST/usr/doc/wmeyes-0.1
mkdir -p $DEST/usr/doc/wmfsm-0.34
mkdir -p $DEST/usr/doc/wmifs.app-1.3b
mkdir -p $DEST/usr/doc/wmtetris-0.1
mkdir -p $DEST/usr/doc/wmtictactoe-1.1-1/html
mkdir -p $DEST/usr/share/GNUstep/apps/asmon
mkdir -p $DEST/usr/share/GNUstep/apps/mixer.app
mkdir -p $DEST/usr/share/GNUstep/apps/wmvolman
mkdir -p $DEST/usr/share/GNUstep/apps/wmCalClock
mkdir -p $DEST/usr/share/GNUstep/apps/wmMatrix
mkdir -p $DEST/usr/share/GNUstep/apps/wmeyes
mkdir -p $DEST/usr/share/GNUstep/apps/wmfsm
mkdir -p $DEST/usr/share/GNUstep/apps/wmifs
mkdir -p $DEST/usr/share/GNUstep/apps/wmtetris/wmtetris
mkdir -p $DEST/usr/share/GNUstep/apps/wmtictactoe
mkdir -p $DEST/usr/src/$SOFT-$SOFTVERSION


#------------------( Build The 'asmon' System Monitor Applet )


cd $BUILDIR
tar -xvjf asmon-0.7.tar.bz2
cd asmon-0.7
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp COPYING Changelog INSTALL $DEST/usr/doc/asmon-0.7/
cd asmon
make
install -m 0755 asmon $DEST/usr/share/GNUstep/apps/asmon/
cd $BUILDIR
rm -rf asmon-0.7


#------------------( Build The 'mixer.app' Audio Mixer Applet )


cd $BUILDIR
tar -xvzf Mixer.app-1.8.0.tar.gz
cd Mixer.app-1.8.0
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp COPYING ChangeLog INSTALL README $DEST/usr/doc/mixer.app-1.8.0/
make
install -m 0755 Mixer.app $DEST/usr/share/GNUstep/apps/mixer.app/
cd $BUILDIR
rm -rf Mixer.app-1.8.0


#------------------( Build The 'wmCalClock' Clock Applet )


cd $BUILDIR
tar -xvjf wmCalClock-1.25.tar.bz2
cd wmCalClock-1.25/
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp BUGS CHANGES COPYING HINTS INSTALL README TODO $DEST/usr/doc/wmCalClock-1.25/
cd Src
sed -i -e "s:\$(SYSTEM)::" Makefile
make
install -m 0755 wmCalClock $DEST/usr/share/GNUstep/apps/wmCalClock/wmCalClock
cd $BUILDIR
rm -rf wmCalClock-1.25


#------------------( Build The 'wmMatrix' Matrix Themed Toy Applet )


cd $BUILDIR
tar -xvjf wmMatrix-0.2.tar.bz2
cd wmMatrix-0.2
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
make
install -m 0755 wmMatrix $DEST/usr/share/GNUstep/apps/wmMatrix/wmMatrix
cd $BUILDIR
rm -rf wmMatrix-0.2
cat <<E0F > $DEST/usr/doc/wmMatrix-0.2/README
There is no documentation provided in the
wmMatrix source archive.
E0F


#------------------( Build The 'wmeyes' Crazy Eyes Toy Applet )


cd $BUILDIR
tar -xvjf wmeyes.tar.bz2
cd wmeyes
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp README $DEST/usr/doc/wmeyes-0.1/
xmkmf
make
install -m 0755 wmeyes $DEST/usr/share/GNUstep/apps/wmeyes/wmeyes
cd $BUILDIR
rm -rf wmeyes


#------------------( Build The 'wmfsm' System Monitor Applet )


cd $BUILDIR
tar -xvjf wmfsm-0.34.tar.bz2
cd wmfsm-0.34
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp AUTHORS COPYING ChangeLog ChangeLog.old INSTALL README TODO $DEST/usr/doc/wmfsm-0.34/
cd wmfsm
patch -p0 < $BUILDIR/wmfsm-0.34.linux-fs.patch
cd ../
aclocal
autoconf
automake 
./configure --prefix=/usr
make
make install DESTDIR=$DEST
cd $BUILDIR
rm -rf wmfsm-0.34
mv $DEST/usr/bin/wmfsm $DEST/usr/share/GNUstep/apps/wmfsm/wmfsm


#------------------( Build The 'wmifs.app' System Monitor Applet )


cd $BUILDIR
tar -xvjf wmifs.app.tar.bz2
cd wmifs.app/
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp BUGS CHANGES COPYING HINTS INSTALL README TODO $DEST/usr/doc/wmifs.app-1.3b/
cd wmifs
make
install -m 0755 wmifs $DEST/usr/share/GNUstep/apps/wmifs/wmifs
cp sample.wmifsrc $DEST/etc/wmifsrc
chown root:root $DEST/etc/wmifsrc
chmod 644 $DEST/etc/wmifsrc
cd $BUILDIR
rm -rf wmifs.app


#------------------( Build The 'wmtetris' Video Game Applet )


cd $BUILDIR
tar -xvjf wmtetris-0.1.tar.bz2
cd wmtetris-0.1/
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp README $DEST/usr/doc/wmtetris-0.1/
cd wmtetris
make
install -m 0755 wmtetris $DEST/usr/share/GNUstep/apps/wmtetris/wmtetris
cd $BUILDIR
rm -rf wmtetris-0.1


#------------------( Build The 'wmtictactoe' Video Game Applet )


cd $BUILDIR
tar -xvjf wmtictactoe-1.1-1.tar.bz2
cd wmtictactoe-1.1-1/
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp CHANGES COPYING INSTALL README TODO $DEST/usr/doc/wmtictactoe-1.1-1/
cp licenca_gnu.html $DEST/usr/doc/wmtictactoe-1.1-1/html/
cd wmtictactoe
make
install -m 0755 wmtictactoe $DEST/usr/share/GNUstep/apps/wmtictactoe/wmtictactoe
cd $BUILDIR
rm -rf wmtictactoe-1.1-1


#------------------( Build The 'libdockapp' DockApp Development Standard Library )


cd $BUILDIR
tar -xvjf libdockapp-0.6.1.tar.bz2
cd dockapp-0.6.1
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp AUTHORS BUGS COPYING ChangeLog INSTALL NEWS README $DEST/usr/doc/libdockapp-0.6.1/

./configure \
 	--prefix=/usr \
	--bindir=/usr/bin \
	--libexecdir=/usr/libexec \
	--datadir=/usr/share \
	--localstatedir=/var \
	--libdir=/usr/lib \
	--includedir=/usr/include \
	--oldincludedir=/usr/include \
	--infodir=/usr/info \
	--mandir=/usr/man \
	--without-font \
	--with-x
make install DESTDIR=$DEST
rm -rf $DEST/local
cd $BUILDIR
rm -rf dockapp-0.6.1
mv $DEST/usr/local/share/examples $DEST/usr/doc/libdockapp-0.6.1/
(cd $DEST/usr/doc/libdockapp-0.6.1/examples/dockapp
	mv basic/ ../
	mv rectangles ../
	cd ../
	rmdir dockapp/
)


#------------------( Build The 'wmvolman' Mount Wrapper )


cd $BUILDIR
tar -xvjf wmvolman-0.9.tar.bz2
cd wmvolman-0.9
  chown -R root:root .
    find . -perm 666 -exec chmod 644 {} \;
    find . -perm 664 -exec chmod 644 {} \;
    find . -perm 600 -exec chmod 644 {} \;
    find . -perm 444 -exec chmod 644 {} \;
    find . -perm 400 -exec chmod 644 {} \;
    find . -perm 440 -exec chmod 644 {} \;
    find . -perm 777 -exec chmod 755 {} \;
    find . -perm 775 -exec chmod 755 {} \;
    find . -perm 511 -exec chmod 755 {} \;
    find . -perm 711 -exec chmod 755 {} \;
    find . -perm 555 -exec chmod 755 {} \;
cp AUTHORS COPYING INSTALL NEWS README \
	$DEST/usr/doc/wmvolman-0.9/
./configure \
 	--prefix=/usr
	make install DESTDIR=$DEST
mv $DEST/usr/bin/wmvolman \
	$DEST/usr/share/GNUstep/apps/wmvolman/wmvolman
rmdir $DEST/usr/bin
cd $BUILDIR
rm -rf wmvolman-0.9


#------------------( Create Slack-desc )


cat <<E1F > $DEST/install/slack-desc
          |-----handy-ruler------------------------------------------------------|
wm-applets: wm-applets (Useful and fun WindowMaker applets)
wm-applets: 
wm-applets: These applets are useful and fun tools and games for
wm-applets: the Window Maker window manager. Included are applets
wm-applets: to cover system minoitors, a free space checker,
wm-applets: an audio volume mixer, some games and more.
wm-applets: 
wm-applets: Window Maker is part of the official GNU project.
wm-applets: 
wm-applets: 
wm-applets: 
E1F


#------------------( Remove Unneeded Symbols And Sections From Binaries )


( cd $DEST
     find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
     find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
)


#------------------( Copy The Build Script Into The Package )


cp $BUILDIR/build-$SOFT.sh $DEST/usr/src/$SOFT-$SOFTVERSION/build-$SOFT.sh


#------------------( Create The Applet's Menu Section )


mv $DEST/usr/bin/wmifs $DEST/usr/share/GNUstep/apps/wmifs/wmifs
rmdir $DEST/usr/bin

cat <<E2F > $DEST/etc/WindowMaker/Zenwalk-Defaults/Menus/menu-tail-applets
	"Applets" MENU
		"Clock" EXEC /usr/share/GNUstep/apps/wmCalClock/wmCalClock
        "Crazy eyes" EXEC /usr/share/GNUstep/apps/wmeyes/wmeyes
		"External Devices" EXEC /usr/share/GNUstep/apps/mixer.app/wmvolman
        "Free space meter" EXEC /usr/share/GNUstep/apps/wmfsm/wmfsm
        "Matrix" EXEC /usr/share/GNUstep/apps/wmMatrix/wmMatrix
		"Mixer" EXEC /usr/share/GNUstep/apps/mixer.app/Mixer
        "Network monitor" EXEC  /usr/share/GNUstep/apps/wmifs/wmifs
        "System monitor" EXEC /usr/share/GNUstep/apps/Asmon/asmon
        "Tetris" EXEC /usr/share/GNUstep/apps/wmtetris/wmtetris
        "Tic-tac-toe" EXEC /usr/share/GNUstep/apps/wmtictactoe/wmtictactoe
	"Applets" END
E2F


#------------------( Compress The Man Pages )


cp -r $DEST/usr/share/man $DEST/usr/man
( cd $DEST/usr/share 
rm -rf man/
)
gzip -9 $DEST/usr/man/*/*


#------------------( Compress The Package )


cd $DEST
makepkg -l y -c n $BUILDIR/$SOFT-$SOFTVERSION-$ARCH-$BUILDVERSION.tgz


#------------------( Generate The Package's Checksum )


cd $BUILDIR
	md5sum $PACKAGE.tgz > $BUILDIR/$SOFT-$SOFTVERSION-$ARCH-$BUILDVERSION.md5
	
	
#------------------( Create The Dependency Listing )


cd $BUILDIR
cat <<E1F > $SOFT-$SOFTVERSION-$ARCH-$BUILDVERSION.dep
pmount,windowmaker,xorg-libs,xorg-xcb
E1F


#------------------( Clean Our Messy Build Area )


cd $BUILDIR
rm -rf $DEST
